diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
index d8702141f..f3a3b729b 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
@@ -8,10 +8,12 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 
@@ -25,51 +27,49 @@ public class Projectile extends Entity {
     protected float gravity;
     protected float defaultProjectileSpeed;
     protected float projectileSpeed;
-    public Projectile(World world)
-    {
+
+    public Projectile(@NotNull World world) {
         super(world);
-        ticksInAir = 0;
+        this.ticksInAir = 0;
         setSize(0.25F, 0.25F);
 
         initProjectile();
     }
 
-    public Projectile(World world, Mob owner)
-    {
+    public Projectile(@NotNull World world, @NotNull Mob owner) {
         super(world);
-        ticksInAir = 0;
+        this.ticksInAir = 0;
         this.owner = owner;
         setSize(0.25F, 0.25F);
-        moveTo(owner.x, owner.y + (double)owner.getHeadHeight(), owner.z, owner.yRot, owner.xRot);
+        moveTo(owner.x, owner.y + (double) owner.getHeadHeight(), owner.z, owner.yRot, owner.xRot);
         if (owner instanceof IItemHolding && ((IItemHolding) owner).isLeftHanded()) {
-            x += MathHelper.cos((yRot / 180F) * MathHelper.PI) * 0.16F;
-            y -= 0.1D;
-            z += MathHelper.sin((yRot / 180F) * MathHelper.PI) * 0.16F;
+            this.x += MathHelper.cos((this.yRot / 180F) * MathHelper.PI) * 0.16F;
+            this.y -= 0.1D;
+            this.z += MathHelper.sin((this.yRot / 180F) * MathHelper.PI) * 0.16F;
         } else {
-            x -= MathHelper.cos((yRot / 180F) * MathHelper.PI) * 0.16F;
-            y -= 0.1D;
-            z -= MathHelper.sin((yRot / 180F) * MathHelper.PI) * 0.16F;
+            this.x -= MathHelper.cos((this.yRot / 180F) * MathHelper.PI) * 0.16F;
+            this.y -= 0.1D;
+            this.z -= MathHelper.sin((this.yRot / 180F) * MathHelper.PI) * 0.16F;
         }
 
-        setPos(x, y, z);
-        heightOffset = 0.0F;
+        setPos(this.x, this.y, this.z);
+        this.heightOffset = 0.0F;
         float f = 0.4F;
-        xd = -MathHelper.sin((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI) * f;
-        zd = MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI) * f;
-        yd = -MathHelper.sin((xRot / 180F) * MathHelper.PI) * f;
-        setHeading(xd, yd, zd, 1.5F, 1.0F);
+        this.xd = -MathHelper.sin((this.yRot / 180F) * MathHelper.PI) * MathHelper.cos((this.xRot / 180F) * MathHelper.PI) * f;
+        this.zd = MathHelper.cos((this.yRot / 180F) * MathHelper.PI) * MathHelper.cos((this.xRot / 180F) * MathHelper.PI) * f;
+        this.yd = -MathHelper.sin((this.xRot / 180F) * MathHelper.PI) * f;
+        setHeading(this.xd, this.yd, this.zd, 1.5F, 1.0F);
 
         initProjectile();
     }
 
-    public Projectile(World world, double x, double y, double z)
-    {
+    public Projectile(@NotNull World world, double x, double y, double z) {
         super(world);
-        ticksInAir = 0;
-        ticksInGround = 0;
+        this.ticksInAir = 0;
+        this.ticksInGround = 0;
         setSize(0.25F, 0.25F);
         setPos(x, y, z);
-        heightOffset = 0.0F;
+        this.heightOffset = 0.0F;
 
         initProjectile();
     }
@@ -78,16 +78,16 @@ public class Projectile extends Entity {
     protected void defineSynchedData() {
 
     }
-    protected void initProjectile(){
-        damage = 0;
-        defaultGravity = 0.03f;
-        defaultProjectileSpeed = 0.99f;
+
+    protected void initProjectile() {
+        this.damage = 0;
+        this.defaultGravity = 0.03f;
+        this.defaultProjectileSpeed = 0.99f;
     }
 
     @Override
-    public boolean shouldRenderAtSqrDistance(final double distance, final double viewDistanceModifier)
-    {
-        double d1 = this.bb.getSize() * 4D;
+    public boolean shouldRenderAtSqrDistance(final double distance, final double viewDistanceModifier) {
+        double d1 = MathHelper.getAABBSize(this.bb) * 4D;
         d1 *= 64D * viewDistanceModifier;
         return distance < d1 * d1;
     }
@@ -102,29 +102,27 @@ public class Projectile extends Entity {
 
     }
 
-    public void setHeading(double newMotionX, double newMotionY, double newMotionZ, float speed, float randomness)
-    {
+    public void setHeading(double newMotionX, double newMotionY, double newMotionZ, float speed, float randomness) {
         float velocity = MathHelper.sqrt(newMotionX * newMotionX + newMotionY * newMotionY + newMotionZ * newMotionZ);
         newMotionX /= velocity;
         newMotionY /= velocity;
         newMotionZ /= velocity;
-        newMotionX += random.nextGaussian() * 0.0075 * (double)randomness;
-        newMotionY += random.nextGaussian() * 0.0075 * (double)randomness;
-        newMotionZ += random.nextGaussian() * 0.0075 * (double)randomness;
+        newMotionX += this.random.nextGaussian() * 0.0075 * (double) randomness;
+        newMotionY += this.random.nextGaussian() * 0.0075 * (double) randomness;
+        newMotionZ += this.random.nextGaussian() * 0.0075 * (double) randomness;
         newMotionX *= speed;
         newMotionY *= speed;
         newMotionZ *= speed;
-        xd = newMotionX;
-        yd = newMotionY;
-        zd = newMotionZ;
+        this.xd = newMotionX;
+        this.yd = newMotionY;
+        this.zd = newMotionZ;
         float f3 = MathHelper.sqrt(newMotionX * newMotionX + newMotionZ * newMotionZ);
-        yRotO = yRot = (float)((java.lang.Math.atan2(newMotionX, newMotionZ) * 180D) / Math.PI);
-        xRotO = xRot = (float)((java.lang.Math.atan2(newMotionY, f3) * 180D) / Math.PI);
-        ticksInGround = 0;
+        this.yRotO = this.yRot = (float) ((java.lang.Math.atan2(newMotionX, newMotionZ) * 180D) / Math.PI);
+        this.xRotO = this.xRot = (float) ((java.lang.Math.atan2(newMotionY, f3) * 180D) / Math.PI);
+        this.ticksInGround = 0;
     }
 
-    public void setHeadingPrecise(double newMotionX, double newMotionY, double newMotionZ, float speed)
-    {
+    public void setHeadingPrecise(double newMotionX, double newMotionY, double newMotionZ, float speed) {
         float velocity = MathHelper.sqrt(newMotionX * newMotionX + newMotionY * newMotionY + newMotionZ * newMotionZ);
         newMotionX /= velocity;
         newMotionY /= velocity;
@@ -132,138 +130,134 @@ public class Projectile extends Entity {
         newMotionX *= speed;
         newMotionY *= speed;
         newMotionZ *= speed;
-        xd = newMotionX;
-        yd = newMotionY;
-        zd = newMotionZ;
+        this.xd = newMotionX;
+        this.yd = newMotionY;
+        this.zd = newMotionZ;
         float horizontalVelocity = MathHelper.sqrt(newMotionX * newMotionX + newMotionZ * newMotionZ);
-        yRotO = yRot = (float)((Math.atan2(newMotionX, newMotionZ) * 180D) / Math.PI);
-        xRotO = xRot = (float)((Math.atan2(newMotionY, horizontalVelocity) * 180D) / Math.PI);
-        ticksInGround = 0;
+        this.yRotO = this.yRot = (float) ((Math.atan2(newMotionX, newMotionZ) * 180D) / Math.PI);
+        this.xRotO = this.xRot = (float) ((Math.atan2(newMotionY, horizontalVelocity) * 180D) / Math.PI);
+        this.ticksInGround = 0;
     }
 
 
     @Override
-    public void lerpMotion(double xd, double yd, double zd)
-    {
+    public void lerpMotion(double xd, double yd, double zd) {
         this.xd = xd;
         this.yd = yd;
         this.zd = zd;
-        if(xRotO == 0.0F && yRotO == 0.0F)
-        {
+        if (this.xRotO == 0.0F && this.yRotO == 0.0F) {
             float f = MathHelper.sqrt(xd * xd + zd * zd);
-            yRotO = yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
-            xRotO = xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
+            this.yRotO = this.yRot = (float) ((Math.atan2(xd, zd) * 180D) / Math.PI);
+            this.xRotO = this.xRot = (float) ((Math.atan2(yd, f) * 180D) / Math.PI);
         }
     }
 
     @Override
-    public void tick()
-    {
-        gravity = defaultGravity;
-        projectileSpeed = defaultProjectileSpeed;
+    public void tick() {
+        this.gravity = this.defaultGravity;
+        this.projectileSpeed = this.defaultProjectileSpeed;
         super.tick();
-        ticksInAir++;
+        this.ticksInAir++;
 
         HitResult movingobjectposition = getHitResult();
-        Vec3 oldPosition = Vec3.fromPool(x, y, z);
-        Vec3 newPosition = Vec3.fromPool(x + xd, y + yd, z + zd);
-        if(movingobjectposition != null)
-        {
-            newPosition = Vec3.fromPool(movingobjectposition.location.x, movingobjectposition.location.y, movingobjectposition.location.z);
+        Vector3dc oldPosition = new Vector3d(this.x, this.y, this.z);
+        Vector3dc newPosition = new Vector3d(this.x + this.xd, this.y + this.yd, this.z + this.zd);
+        if (movingobjectposition != null) {
+            newPosition = movingobjectposition.location;
         }
-        if(!world.isClientSide)
-        {
+        if (!this.world.isClientSide) {
             Entity entity = null;
-            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.expand(xd, yd, zd).grow(1.0D, 1.0D, 1.0D));
+            AABBd r = MathHelper.aabbExpand(this.bb, this.xd, this.yd, this.zd, new AABBd());
+            MathHelper.aabbGrow(r, 1.0D, 1.0D, 1.0D, r);
+            List<Entity> list = this.world.getEntitiesWithinAABBExcludingEntity(this, r);
             double d = 0.0D;
             for (Entity entity1 : list) {
-                if (!entity1.isPickable() || entity1 == owner && ticksInAir < 5) {
+                if (!entity1.isPickable() || entity1 == this.owner && this.ticksInAir < 5) {
                     continue;
                 }
                 float f4 = 0.3F;
-                AABB axisalignedbb = entity1.bb.grow(f4, f4, f4);
-                HitResult movingobjectposition1 = axisalignedbb.clip(oldPosition, newPosition);
-                if (movingobjectposition1 == null) {
+                AABBdc aabb = MathHelper.aabbGrow(entity1.bb, f4, f4, f4, new AABBd());
+                HitResult hitResult = MathHelper.aabbClip(aabb, oldPosition, newPosition);
+                if (hitResult == null) {
                     continue;
                 }
-                double d1 = oldPosition.distanceTo(movingobjectposition1.location);
+                double d1 = oldPosition.distance(hitResult.location);
                 if (d1 < d || d == 0.0D) {
                     entity = entity1;
                     d = d1;
                 }
             }
 
-            if(entity != null)
-            {
+            if (entity != null) {
                 movingobjectposition = new HitResult.Entity(entity);
             }
         }
-        if(movingobjectposition != null)
-        {
+        if (movingobjectposition != null) {
             onHit(movingobjectposition);
         }
         afterTick();
     }
-    public HitResult getHitResult(){
-        Vec3 oldPosition = Vec3.fromPool(x, y, z);
-        Vec3 newPosition = Vec3.fromPool(x + xd, y + yd, z + zd);
-        return world.checkBlockCollisionBetweenPoints(oldPosition, newPosition);
+
+    public HitResult getHitResult() {
+        Vector3d oldPosition = new Vector3d(this.x, this.y, this.z);
+        Vector3d newPosition = new Vector3d(this.x + this.xd, this.y + this.yd, this.z + this.zd);
+        return this.world.checkBlockCollisionBetweenPoints(oldPosition, newPosition);
     }
-    public void onHit(@NotNull HitResult hitResult){
-        if(hitResult instanceof HitResult.Entity hitEntity) {
-            hitEntity.entity.hurt(owner, damage, DamageType.COMBAT);
+
+    public void onHit(@NotNull HitResult hitResult) {
+        if (hitResult instanceof HitResult.Entity hitEntity) {
+            hitEntity.entity.hurt(this.owner, this.damage, DamageType.COMBAT);
         }
-        if (modelItem != null){
-            for(int j = 0; j < 8; j++)
-            {
-                world.spawnParticle("item", x, y, z, 0.0, 0.0D, 0.0D, modelItem.id);
+        if (this.modelItem != null) {
+            for (int j = 0; j < 8; j++) {
+                this.world.spawnParticle("item", this.x, this.y, this.z, 0.0, 0.0D, 0.0D, this.modelItem.id);
             }
         }
         remove();
     }
-    public void afterTick(){
-        x += xd;
-        y += yd;
-        z += zd;
-        float f = MathHelper.sqrt(xd * xd + zd * zd);
-        yRot = (float)((java.lang.Math.atan2(xd, zd) * 180D) / Math.PI);
-        xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
-        while (xRot - xRotO < -180F) {
-            xRotO -= 360F;
+
+    public void afterTick() {
+        this.x += this.xd;
+        this.y += this.yd;
+        this.z += this.zd;
+        float f = MathHelper.sqrt(this.xd * this.xd + this.zd * this.zd);
+        this.yRot = (float) ((java.lang.Math.atan2(this.xd, this.zd) * 180D) / Math.PI);
+        this.xRot = (float) ((Math.atan2(this.yd, f) * 180D) / Math.PI);
+        while (this.xRot - this.xRotO < -180F) {
+            this.xRotO -= 360F;
         }
-        while (xRot - xRotO >= 180F) {
-            xRotO += 360F;
+        while (this.xRot - this.xRotO >= 180F) {
+            this.xRotO += 360F;
         }
-        while (yRot - yRotO < -180F) {
-            yRotO -= 360F;
+        while (this.yRot - this.yRotO < -180F) {
+            this.yRotO -= 360F;
         }
-        while (yRot - yRotO >= 180F) {
-            yRotO += 360F;
+        while (this.yRot - this.yRotO >= 180F) {
+            this.yRotO += 360F;
         }
-        xRot = xRotO + (xRot - xRotO) * 0.2F;
-        yRot = yRotO + (yRot - yRotO) * 0.2F;
-        if(isInWater())
-        {
+        this.xRot = this.xRotO + (this.xRot - this.xRotO) * 0.2F;
+        this.yRot = this.yRotO + (this.yRot - this.yRotO) * 0.2F;
+        if (isInWater()) {
             waterTick();
         }
-        xd *= projectileSpeed;
-        yd *= projectileSpeed;
-        zd *= projectileSpeed;
-        yd -= gravity;
-        setPos(x, y, z);
+        this.xd *= this.projectileSpeed;
+        this.yd *= this.projectileSpeed;
+        this.zd *= this.projectileSpeed;
+        this.yd -= this.gravity;
+        setPos(this.x, this.y, this.z);
     }
-    public void waterTick(){
-        for(int k = 0; k < 4; k++)
-        {
+
+    public void waterTick() {
+        for (int k = 0; k < 4; k++) {
             double particleDistance = 0.25F;
-            world.spawnParticle("bubble", x - xd * particleDistance, y - yd * particleDistance, z - zd * particleDistance, xd, yd, zd, 0);
+            this.world.spawnParticle("bubble", this.x - this.xd * particleDistance, this.y - this.yd * particleDistance, this.z - this.zd * particleDistance, this.xd, this.yd, this.zd, 0);
         }
 
-        projectileSpeed = 0.8F;
+        this.projectileSpeed = 0.8F;
     }
+
     @Override
-    public float getShadowHeightOffs()
-    {
+    public float getShadowHeightOffs() {
         return 0.0F;
     }
 
